interface BaseOptions<T> {
    message: string;
    default?: T;
}
interface InputOptions extends BaseOptions<string> {
}
export declare function input(question: string | InputOptions): Promise<string>;
export declare function password(question: string | InputOptions): Promise<string>;
interface ChoicesOptions<T extends string> extends BaseOptions<T> {
    choices: ReadonlyArray<T>;
}
export declare function choices<T extends string>(question: ChoicesOptions<T>): Promise<T>;
interface ConfirmOptions extends BaseOptions<boolean> {
}
export declare function confirm(question: string | ConfirmOptions): Promise<boolean>;
export {};
