"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const inquirer = require("inquirer");
function input(question) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof question === 'string') {
            question = { message: question };
        }
        const { answer } = yield inquirer.prompt(Object.assign({}, question, { name: 'answer' }));
        return answer;
    });
}
exports.input = input;
function password(question) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof question === 'string') {
            question = { message: question };
        }
        const { answer } = yield inquirer.prompt(Object.assign({}, question, { name: 'answer', type: 'password' }));
        return answer;
    });
}
exports.password = password;
function choices(question) {
    return __awaiter(this, void 0, void 0, function* () {
        const { answer } = yield inquirer.prompt(Object.assign({}, question, { name: 'answer', type: 'list' }));
        return answer;
    });
}
exports.choices = choices;
function confirm(question) {
    return __awaiter(this, void 0, void 0, function* () {
        if (typeof question === 'string') {
            question = { message: question };
        }
        const { answer } = yield inquirer.prompt(Object.assign({}, question, { name: 'answer', type: 'confirm' }));
        return answer;
    });
}
exports.confirm = confirm;
//# sourceMappingURL=prompt.js.map